// ---------- Attention: Generated code, please do not modify! -----------  

/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.myfaces.tobago.component;

import javax.faces.context.FacesContext;
import org.apache.myfaces.tobago.context.Markup;
import org.apache.myfaces.tobago.internal.component.AbstractUIOut;
import org.apache.myfaces.tobago.renderkit.css.CustomClass;
import org.apache.myfaces.tobago.renderkit.css.Style;
import org.apache.myfaces.tobago.sanitizer.SanitizeMode;
import org.apache.myfaces.tobago.internal.util.ArrayUtils;
import org.apache.myfaces.tobago.internal.util.StringUtils;
import org.apache.myfaces.tobago.internal.util.Deprecation;
import javax.el.ELException;
import javax.faces.FacesException;
import java.util.Arrays;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import javax.el.MethodExpression;
import javax.el.ValueExpression;

/** 
 Renders a text
  * UIComponent class, generated from template {@code component.stg} with class
  * {@link org.apache.myfaces.tobago.internal.taglib.component.OutTagDeclaration}.
 */
public class UIOut
    extends AbstractUIOut implements Visual {

  public static final String COMPONENT_TYPE = "org.apache.myfaces.tobago.Out";

  public static final String COMPONENT_FAMILY = "javax.faces.Output";


  enum PropertyKeys {
    markup,
    labelLayout,
    customClass,
    tip,
    style,
    createSpan,
    label,
    escape,
    sanitize,
  }

  public String getFamily() {
    return COMPONENT_FAMILY;
  }


  public org.apache.myfaces.tobago.context.Markup getMarkup() {
    Object object = getStateHelper().eval(PropertyKeys.markup);
    if (object != null) {
      return Markup.valueOf(object);
    }
    return null;
  }

  public void setMarkup(org.apache.myfaces.tobago.context.Markup markup) {
    getStateHelper().put(PropertyKeys.markup, markup);
  }

  /**
  Defines the position of the label relative to the field.
   The default is flexLeft, if the label is set, or none, if the label isn't set.

  */
  public org.apache.myfaces.tobago.component.LabelLayout getLabelLayout() {
    org.apache.myfaces.tobago.component.LabelLayout labelLayout = (org.apache.myfaces.tobago.component.LabelLayout) getStateHelper().eval(PropertyKeys.labelLayout);
    if (labelLayout != null) {
      return labelLayout;
    }
    return getLabel() != null ? org.apache.myfaces.tobago.component.LabelLayout.flexLeft : org.apache.myfaces.tobago.component.LabelLayout.none;
  }

  public void setLabelLayout(org.apache.myfaces.tobago.component.LabelLayout labelLayout) {
    getStateHelper().put(PropertyKeys.labelLayout, labelLayout);
  }

  /**
  Sets a CSS class in its parent, if the parent supports it.

   Which this feature it is possible to put a CSS class name into a component with the &lt;tc:style&gt; tag. Example:

   <pre>
   &lt;tc:in&gt;
     &lt;tc:style customClass="my-emphasized"/&gt;
   &lt;/tc:in&gt;
   </pre>

   One capability is, to used external CSS libs.
   <br>
   This feature should not be used imprudent.
   Because it might be unstable against changes in the renderered HTML code.

  */
  public org.apache.myfaces.tobago.renderkit.css.CustomClass getCustomClass() {
    return (org.apache.myfaces.tobago.renderkit.css.CustomClass) getStateHelper().eval(PropertyKeys.customClass);
  }

  public void setCustomClass(org.apache.myfaces.tobago.renderkit.css.CustomClass customClass) {
    getStateHelper().put(PropertyKeys.customClass, customClass);
  }

  /**
  Text value to display as tooltip.

  */
  public java.lang.String getTip() {
    return (java.lang.String) getStateHelper().eval(PropertyKeys.tip);
  }

  public void setTip(java.lang.String tip) {
    getStateHelper().put(PropertyKeys.tip, tip);
  }

  /**
  For internal use. Used for rendering, if there is a child tag &lt;tc:style&gt;

  */
  public org.apache.myfaces.tobago.renderkit.css.Style getStyle() {
    return (org.apache.myfaces.tobago.renderkit.css.Style) getStateHelper().eval(PropertyKeys.style);
  }

  public void setStyle(org.apache.myfaces.tobago.renderkit.css.Style style) {
    getStateHelper().put(PropertyKeys.style, style);
  }

  /**
  Indicates that the renderer should create an element in the output language
   (e. g. an span or div tag around the output text).
   Use true, if you enable the possibility to apply styles to the output.
   Use false, if you want to keep the code small (especially inside of sheets).
  <br>Default: <code>true</code>
  */
  public boolean isCreateSpan() {
    Boolean bool = (Boolean) getStateHelper().eval(PropertyKeys.createSpan);
    if (bool != null) {
      return bool;
    }
    return true;
  }

  public void setCreateSpan(boolean createSpan) {
    getStateHelper().put(PropertyKeys.createSpan, createSpan);
  }

  /**
  A localized user presentable label for this component.

  */
  public java.lang.String getLabel() {
    return (java.lang.String) getStateHelper().eval(PropertyKeys.label);
  }

  public void setLabel(java.lang.String label) {
    getStateHelper().put(PropertyKeys.label, label);
  }

  /**
  Flag indicating that characters that are
   sensitive in HTML and XML markup must be escaped.
  <br>Default: <code>true</code>
  */
  public boolean isEscape() {
    Boolean bool = (Boolean) getStateHelper().eval(PropertyKeys.escape);
    if (bool != null) {
      return bool;
    }
    return true;
  }

  public void setEscape(boolean escape) {
    getStateHelper().put(PropertyKeys.escape, escape);
  }

  /**
  Should HTML content sanitized?
   The effect of sanitizing depends on the configuration.
   The value "auto" means, that sanitizing take place for
   <ul>
     <li>tc:out when escape="false" or</li>
     <li>tc:textarea when attribute data-html-editor is set,</li>
   </ul>
   because that are the critical parts.
  <br>Default: <code>auto</code><br>Allowed Values: <code>auto,never</code>
  */
  public org.apache.myfaces.tobago.sanitizer.SanitizeMode getSanitize() {
    org.apache.myfaces.tobago.sanitizer.SanitizeMode sanitize = (org.apache.myfaces.tobago.sanitizer.SanitizeMode) getStateHelper().eval(PropertyKeys.sanitize);
    if (sanitize != null) {
      return sanitize;
    }
    return org.apache.myfaces.tobago.sanitizer.SanitizeMode.auto;
  }

  public void setSanitize(org.apache.myfaces.tobago.sanitizer.SanitizeMode sanitize) {
    getStateHelper().put(PropertyKeys.sanitize, sanitize);
  }


}